      SUBROUTINE ELFIL
C
C       FILTRAGE EN SEQUENCE SUR TENDANCE/SAISONNIER/IRREGULIER
C       SOURCE: CENSUS X-11

!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002   

	Integer*4   NF
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)

        Real*4 XEL(NF),DXEL(NF,2),serx(NF)

      	Real*4 BP,BI,belim,DATDEP,SERI,TEND,SAIS,SAISb,REST
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NTOT,isort
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NTOT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),saisB(NF),REST(NF)

c	type*,'ELFIL: interu',interu

	kbcl=1                    ! nb de bouclages pour ELFIL
	isort=3			  ! numero de la sortie de ELFIL (1-3)

      DO 90 I=1,5000   		  
         XEL(I)=0
         TEND(I)=0
         SAIS(I)=0
         REST(I)=0
         serx(I)=0
      DO 90 J=1,2      
         DXEL(I,J)=0                         
   90 CONTINUE   		

      DO 100 I=1,NTOT      
         XEL(I)=SERI(I)                         !B1
  100 CONTINUE

!	type*,'TENDANCE 1 , largeur',limp,' points'
      IRB=0

      CALL ELTEND(XEL,IRB,1)                    !B2-->C1

      DO 200 I=1,NTOT      
         XEL(I)=SERI(I)-TEND(I)                 !B3
  200 CONTINUE
      IRB=1

c      TYPE*,'SAISONNIER 1',lps,' points. Interu:',Interu

      CALL ELSAIS(XEL,IRB)                      !B4,5-->S1

      DO 300 I=1,NTOT
         XEL(I)=SERI(I)-SAIS(I)                 !B6
 16      format('Elfil',i5,3f10.3)
  300 CONTINUE
      LAPM=LPT
      IRB=0

c      TYPE*,'TENDANCE 2 ,largeur',lpair,' points'

      CALL ELTEND(XEL,IRB,2)                    !B7-->C2

      DO 400 I=1,NTOT
         XEL(I)=SERI(I)-TEND(I)                 !B8
  400 CONTINUE
      IRB=1

!      TYPE*,'SAISONNIER 2 ',lps,' points'

      CALL ELSAIS(XEL,IRB)                      !B9,10-->S2
          
C            SORTIE 1

      IF(ISORT.EQ.1) THEN
         TYPE*,'        ****** ELFIL,SORTIE 1 ******'
         GO TO 1050                     
      ENDIF

      IBOUCLE=0
      IRB=0
  450 CONTINUE
      IBOUCLE=IBOUCLE+1
      ITS=(IBOUCLE+1)*2

      DO 500 I=1,NTOT
         XEL(I)=SERI(I)-SAIS(I)-TEND(I)         !B11,12 et C11,12
  500 CONTINUE

!      TYPE*,'FILTRAGE DE L''IRREGULIER',IBOUCLE

      write(16,11) 
 11   format(78('-')/'ELFIL/ELCOPO')

      CALL ELCOPO(XEL,DXEL)                  !B17 et C17

      DO 600 I=1,NTOT
         serx(I)=SERI(I)-DXEL(I,2)               !C,D1
	 XEL(I)=serx(I)
  600 CONTINUE
 
!	type*,'Tendance, largeur',limp,' points'

      CALL ELTEND(XEL,IRB,1)                   !C,D2-->C3,5

      DO 700 I=1,NTOT
         XEL(I)=SERx(I)-TEND(I)                 !C,D4
  700 CONTINUE
  705 format(I8,6f10.3)

c      TYPE*,'SAISONNIER C,D5-->S3,5',lps,' points'

      CALL ELSAIS(XEL,IRB)                   !C,D5-->S3,5

      DO 800 I=1,NTOT
         XEL(I)=SERx(I)-SAIS(I)              !C,D6
 800  CONTINUE    

c      TYPE*,'TENDANCE',ITS,' largeur',lpair,' points'

      CALL ELTEND(XEL,IRB,2)                   !C,D7-->C4,6      

      DO 900 I=1,NTOT
         XEL(I)=SERx(I)-TEND(I)              !C,D9
  900 CONTINUE

      CALL ELSAIS(XEL,IRB)                   !C,D10-->S4,6

C             SORTIE 2

      IF(ISORT.EQ.2) THEN
c	type*,' '
      TYPE*,'        ****** ELFIL,SORTIE 2 ******'
      GO TO 1050
                    ENDIF
      IF(IBOUCLE.le.kbcl) GO TO 450
      DO 1000 I=1,NTOT
         XEL(I)=SERx(I)-SAIS(I)              !D11
 1000 CONTINUE

c      TYPE*,'TENDANCE FINALE ET SORTIE 3, largeur',LPS,' points'

      CALL ELTEND(XEL,IRB,0)                 !D12

C             SORTIE 3

 1050 CONTINUE

      DO 1100 I=1,NTOT
         REST(I)=SERI(I)-SAIS(I)-TEND(I)     !D13
 1100 CONTINUE

      RETURN
      END

