      SUBROUTINE ELFIL2(lpsb,chan)
C
C     FILTRAGE EN SEQUENCE SUR TENDANCE/SAISONNIER/IRREGULIER
C               BASCULAGE ENTRE deux TERMES

!       Auteur: M. Feissel-Vernier <feissel@ensg.ign.fr>
!       Juillet 2002   

	Implicit none
	Integer*4   NF,lpsb
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)

        Real*4       ANNU(NF),SARI(NF),chan(NF)
	Integer*4    I,itour,J,kbasc,lpsa

!       Declarations pour l'interface avec ELFIL

      	Real*4    BP,BI,belim,DATDEP,  SERI,TEND,SAIS,SAISb,REST 
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NTOT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NTOT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

	kbasc=10                   ! nb de bascules pour ELFIL2

      J=1
      DO 210 I=1,NTOT
c	del(I,2)=del(I,2)*100.
        SARI(I)=SERI(I)
	annu(I)=0.
        CHAN(I)=0.
  210 CONTINUE

C    BASCULAGE

      lpsa=lps  ! On sauvegarde la valeur initiale de lps

      DO 240 ITOUR=1,KBASC
      			
         LPS=lpsa

c         type*,'Extraction du cycle A',kbasc
     			
         CALL ELFIL

         DO 220 I=1,NTOT
            SERI(I)=SARI(I)-SAIS(I) ! - Cycle A
            ANNU(I)=SAIS(I)
 220     CONTINUE
      			
         LPS=lpsb

c         type*,'Extraction du cycle B',kbasc
      		
	 CALL ELFIL
                        
         DO 222 I=1,NTOT                           
            SERI(I)=SARI(I)-SAIS(I)  ! - Cycle B
            CHAN(I)=SAIS(I)
 222     CONTINUE

  240 CONTINUE

         
      DO 250 I=1,NTOT
         SERI(I)=SARI(I)                          ! On restitue SERI(I) initial
         sais(I)=annu(I)
         saisb(I)=chan(I)
         REST(I)=SERI(I)-annu(I)-chan(I)-TEND(I)  ! On reconstitue REST(I)
  250 CONTINUE
      			
      LPS=lpsa  ! On retablit la valeur initiale de lps

      Return
      END

