      SUBROUTINE ELTEND(XEL,IRB,KPAIR)

	Integer*4   NF
	Parameter (NF=50000)   ! Nb de pts dans la serie (sans trous)
	Parameter (NIC=12)    ! Nb max d'inconnues pour MCGAUSS

        Real*4  XEL(NF),YEL(NF),DXEL(NF,2)

      	Real*4    BP,BI,belim,DATDEP,  SERI,TEND,SAIS,SAISb,REST 
	Integer*4 Limp,lpair,kbcl,LPS, INTERU,NT
	COMMON/ELPAR/Limp,lpair,kbcl,LPS,BP,BI,belim,DATDEP,INTERU,NT
	COMMON/ELSER/SERI(NF),TEND(NF),SAIS(NF),SAISb(NF),REST(NF)

!                Pour MCGAUSS

	Real*8    G_A,G_YZ
	Real*4    G_sigma,G_R,G_SIG,G_XS,G_cc
	Integer*4 neq
	Common/CACH/G_A(NF,NIC),G_YZ(NF),G_sigma,G_R(NF),
	1           G_SIG(NIC),G_XS(NIC),G_cc(NIC,NIC)
       
!          MOYENNE GLISSANTE SUR LP POINTS

      DO 90 I=1,NF   			! Ajout, juin 97   
      YEL(I)=0
      TEND(I)=0
      DO 90 J=1,2      
      DXEL(I,J)=0                         
   90 CONTINUE   			! Ajout, juin 97

	if(kpair.eq.1) lapm=limp
	if(kpair.eq.2) lapm=lpair
	if(kpair.eq.0) lapm=LPS

      LP=LAPM/INTERU+0.5
      LPDEM=LP/2

!          ON PERD LP/2 VALEURS AU DEBUT ET A LA FIN

      LD=LPDEM+1
      LF=NT-LPDEM
      IBOUCLE=0
   50 CONTINUE    
      IBOUCLE=IBOUCLE+1
c      TYPE*,'** ELTEND',NT,LP,LPDEM,LD,LF
      
      DO 200 I=LD,LF
         ACU=0
         JD=I-LPDEM
         JF=I+LPDEM
         DO 150 J=JD,JF
            ACU=ACU+XEL(J)/LP
  150    CONTINUE

!          AFFECTATION DE TENDANCE

         TEND(I)=ACU
c        type*,I,TEND(I)
  200 CONTINUE

!      POUR LES PREMIER ET DERNIER DEMI-CYCLE,
!      ON ADOPTE  LA TENDANCE LINEAIRE ADJACENTE

c      TYPE*,'** ELTEND avant'

c		AVANT

	LD2=LD+LPDEM
	orig=datdep+interu*(LD-1)
	neq=0
	do 210 I=LD,LD2
	   neq=neq+1
           G_A(neq,1)=1.d0
           G_A(neq,2)=datdep+interu*(I-1)
           G_YZ(neq)=tend(I)	
  210	continue

        pav=0
	
	CALL MCGAUSS(Neq,2)

	pav=G_XS(2)
	pavv=pav*365.2422
c	if(kpair.eq.0) write(16,2) pavv,orig
c   2	format(78('-')/'ELTEND'/10x, 
c     .         'Pente ',f10.4,' adoptee avant',f7.0)

c		APRES

	LF2=LF-LPDEM
	orig=datdep+interu*(LF-1)
	neq=0
	do 220 I=LF2,LF
	   neq=neq+1
           G_A(neq,1)=1.d0
           G_A(neq,2)=datdep+interu*(I-1)
           G_YZ(neq)=tend(I)	
  220	continue

        pap=0

c      TYPE*,'** ELTEND 2'
	
	CALL MCGAUSS(Neq,2)

	pap=G_XS(2)
	papp=pap*365.2422
c	if(kpair.eq.0) write(16,3) papp,orig
c   3	format(10x, 'Pente ',f10.4,'/an adoptee apres',f7.0)

      DO 280 I=1,LPDEM
         TEND(I)=TEND(LD)+pav*interu*(I-LD)
         J=NT-I+1
         TEND(J)=TEND(LF)+pap*interu*(J-LF)
  280 CONTINUE

c      TYPE*,'** ELTEND 3'

      IF(IRB.EQ.0.OR.IBOUCLE.EQ.2) GO TO 400

      IF (IRB.EQ.1.AND.IBOUCLE.EQ.1) THEN
         DO 300 I=1,NT
            YEL(I)=XEL(I)-TEND(I)
  300    CONTINUE

c	 write(6,11) 

 	 write(16,11) 
11	 format(78('-')/'ELTEND/ELCOPO')

         CALL ELCOPO(YEL,DXEL)

         DO 350 I=1,NT
            XEL(I)=XEL(I)-DXEL(I,2)
  350    CONTINUE
         GO TO 50                              
      ENDIF

  400	continue
        RETURN
      END     
